#
# spec file for package rubygem-unicorn
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


#
# This file was generated with a gem2rpm.yml and not just plain gem2rpm.
# All sections marked as MANUAL, license headers, summaries and descriptions
# can be maintained in that file. Please consult this file before editing any
# of those fields
#

Name:           rubygem-unicorn
Version:        5.1.0
Release:        2.7
%define mod_name unicorn
%define mod_full_name %{mod_name}-%{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  %{rubydevel < 3.0}
BuildRequires:  %{rubygem gem2rpm}
BuildRequires:  ruby-macros >= 5
BuildRequires:  update-alternatives
Url:            http://unicorn.bogomips.org/
Source:         http://rubygems.org/gems/%{mod_full_name}.gem
Source1:        rubygem-unicorn-rpmlintrc
Source2:        series
Source3:        gem2rpm.yml
# MANUAL
Patch0:         unicorn-4.6.3_fix_shebangline.patch
# /MANUAL
Summary:        Rack HTTP server for fast clients and Unix
License:        GPL-2.0 or GPL-3.0 or Ruby
Group:          Development/Languages/Ruby
PreReq:         update-alternatives

%description
unicorn is an HTTP server for Rack applications designed to only serve
fast clients on low-latency, high-bandwidth connections and take
advantage of features in Unix/Unix-like kernels.  Slow clients should
only be served by placing a reverse proxy capable of fully buffering
both the the request and response in between unicorn and slow clients.

%prep
%gem_unpack
%patch0 -p0
find -type f -print0 | xargs -0 touch -r %{S:0}
%gem_build

%build

%install
%gem_install \
  --symlink-binaries \
  --doc-files="COPYING LICENSE NEWS README" \
  -f
%gem_cleanup

%gem_packages

%changelog
* Wed Apr  6 2016 coolo@suse.com
- updated to version 5.1.0
  see installed NEWS
  === unicorn 5.1.0 - rack is optional, again / 2016-04-01 00:35 UTC
    Note: no code changes since 5.1.0.pre1 from January.^WNo, wait,
    last minute performance improvement added today.  See below.
    The big change is rack is not required (but still recommended).
    Applications are expected to depend on rack on their own so they can
    specify the version of rack they prefer without unicorn pulling
    in a newer, potentially incompatible version.
    unicorn will always attempt to work with multiple versions of rack
    as practical.
    The HTTP parser also switched to using the TypedData C-API for
    extra type safety and memory usage accounting support in the
    'objspace' extension.
    Thanks to Adam Duke to bringing the rack change to our attention
    and Aaron Patterson for helping with the matter.
    Last minute change: we now support the new leftpad() syscall under
    Linux for major performance and security improvement:
    http://mid.gmane.org/1459463613-32473-1-git-send-email-richard@nod.at
    8^H9 changes since 5.0.1:
    http: TypedData C-API conversion
    various documentation updates
    doc: bump olddoc to ~> 1.2 for extra NNTP URL
    rack is optional at runtime, required for dev
    doc update for ClientShutdown exceptions class
    unicorn 5.1.0.pre1 - rack is optional, again
    doc: reference --keep-file-descriptors for "bundle exec"
    doc: further trimming to reduce noise
    use leftpad Linux syscall for speed!
  === unicorn 5.1.0.pre1 - rack is optional, again / 2016-01-27 23:08 UTC
    The big change is rack is not required (but still recommended).
    Applications are expected to depend on rack on their own so they can
    specify the version of rack they prefer without unicorn pulling
    in a newer, potentially incompatible version.
    unicorn will always attempt to work with multiple versions of rack
    as practical.
    The HTTP parser also switched to using the TypedData C-API for
    extra type safety and memory usage accounting support in the
    'objspace' extension.
    Thanks to Adam Duke to bringing the rack change to our attention
    and Aaron Patterson for helping with the matter.
    There might be more documentation-related changes before 5.1.0
    final.  I am considering dropping pandoc from manpage generation
    and relying on pod2man (from Perl) because it has a wider install
    base.
    5 changes since v5.0.1:
    http: TypedData C-API conversion
    various documentation updates
    doc: bump olddoc to ~> 1.2 for extra NNTP URL
    rack is optional at runtime, required for dev
    doc update for ClientShutdown exceptions class
  === unicorn 5.0.1 - continuing to violate Rack SPEC / 2015-11-17 22:44 UTC
    Once again, we allow nil values in response headers.  We've had
    this bug since March 2009, and thus cannot expect existing
    applications and middlewares running unicorn to fix this.
    Unfortunately, supporting this bug contributes to application
    server lock-in, but at least we'll document it as such.
    Thanks to Owen Ou <o@heroku.com> for reporting this regression:
    http://bogomips.org/unicorn-public/CAO47=rJa=zRcLn_Xm4v2cHPr6c0UswaFC_omYFEH+baSxHOWKQ@mail.gmail.com/
    Additionally, systemd examples are now in the examples/ directory
    based on a post by Christos Trochalakis <yatiohi@ideopolis.gr>:
    http://bogomips.org/unicorn-public/20150708130821.GA1361@luke.ws.skroutz.gr/
  === unicorn 5.0.0 - most boring major release. EVER. / 2015-11-01 08:48 UTC
    An evolutionary dead-end since its announcement[1] nearly six years
    ago, this old-fashioned preforker has had enough bugs and missteps
    that it's managed to hit version 5!
    I wish I could say unicorn 5 is leaps and bounds better than 4, but
    it is not.  This major version change allows us to drop some cruft
    and unused features which accumulated over the years, resulting in
    several kilobytes of memory saved[2]!
    Compatibility:
  * The horrible, proprietary (:P) "Status:" response header is
    finally gone, saving at least 16 precious bytes in every HTTP
    response.  This should make it easier to write custom HTTP clients
    which are compatible across all HTTP servers.  It will hopefully
    make migrating between different Rack servers easier for new
    projects.
  * Ruby 1.8 support removed.  Ruby 1.9.3 is currently the earliest
    supported version.  However, expect minor, likely-unnoticeable
    performance regressions if you use Ruby 2.1 or earlier.  Going
    forward, unicorn will favor the latest version (currently 2.2) of
    the mainline Ruby implementation, potentially sacrificing
    performance on older Rubies.
  * Some internal, undocumented features and APIs used by
    derivative servers are gone; removing bloat and slightly lowering
    memory use.  We have never and will never endorse the use of any
    applications or middleware with a dependency on unicorn,
    applications should be written for Rack instead.
    Note: Rainbows! 5.0 will be released next week or so to be
    compatible with unicorn 5.x
    New features:
  * sd_listen_fds(3) emulation added for systemd compatibility.
    You may now stop using PID files and other process monitoring
    software when using systemd.
  * Newly-set TCP socket options are now applied to inherited sockets.
  * Dynamic changes in the application to Rack::Utils::HTTP_STATUS
    hash is now supported; allowing users to set custom status lines
    in Rack to be reflected in unicorn.  This feature causes a minor
    performance regression, but is made up for Ruby 2.2 users with
    other optimizations.
  * The monotonic clock is used under Ruby 2.1+, making the
    timeout feature immune to system clock changes.
    As unicorn may be used anonymously without registration, the
    project is committed to supporting anonymous and pseudonymous
    help requests, contributions and feedback via plain-text mail to:
    unicorn-public@bogomips.org
    The mail submission port (587) is open to those behind firewalls
    and allows access via Tor and anonymous remailers.
    Archives are accessible via: http://bogomips.org/unicorn-public/
    and mirrored to various other places, so you do not need to use
    a valid address when posting.
    Finally, rest assured the core design of unicorn will never change.
    It will never use new-fangled things like threads, kqueue or epoll;
    but will always remain a preforking server serving one client
    per-process.
    [1] http://mid.gmane.org/20090211230457.GB22926@dcvr.yhbt.net
    [2] this would've been like, totally gnarly in the 80s!
* Wed Mar 23 2016 olaf@aepfle.de
- Force fixed timestamps for patched gems (bsc#916047)
* Wed Nov 18 2015 coolo@suse.com
- updated to version 5.0.1
  see installed NEWS
* Mon Nov  2 2015 coolo@suse.com
- updated to version 5.0.0
  see installed NEWS
  === unicorn 5.0.0.pre2 - another prerelease! / 2015-07-06 21:37 UTC
    There is a minor TCP socket options are now applied to inherited
    sockets, and we have native support for inheriting sockets from
    systemd (by emulating the sd_listen_fds(3) function).
    Dynamic changes in the application to Rack::Utils::HTTP_STATUS
    codes is now supported, so you can use your own custom status
    lines.
    Ruby 2.2 and later is now favored for performance.
    Optimizations by using constants which made sense in earlier
    versions of Ruby are gone: so users of old Ruby versions
    will see performance regressions.  Ruby 2.2 users should
    see the same or better performance, and we have less code
    as a result.
  * doc: update some invalid URLs
  * apply TCP socket options on inherited sockets
  * reflect changes in Rack::Utils::HTTP_STATUS_CODES
  * reduce constants and optimize for Ruby 2.2
  * http_response: reduce size of multi-line header path
  * emulate sd_listen_fds for systemd support
  * test/unit/test_response.rb: compatibility with older test-unit
    This also includes all changes in unicorn 5.0.0.pre1:
    http://bogomips.org/unicorn-public/m/20150615225652.GA16164@dcvr.yhbt.net.html
  === unicorn 5.0.0.pre1 - incompatible changes! / 2015-06-15 22:49 UTC
    This release finally drops Ruby 1.8 support and requires Ruby 1.9.3
    or later.  The horrible "Status:" header in our HTTP response is
    finally gone, saving at least 16 precious bytes in every single HTTP
    response.
    Under Ruby 2.1 and later, the monotonic clock is used for timeout
    handling for better accuracy.
    Several experimental, unused and undocumented features are removed.
    There's also tiny, minor performance and memory improvements from
    dropping 1.8 compatibility, but probably nothing noticeable on a
    typical real-life (bloated) app.
    The biggest performance improvement we made was to our website by
    switching to olddoc.  Depending on connection speed, latency, and
    renderer performance, it typically loads two to four times faster.
    Finally, for the billionth time: unicorn must never be exposed
    to slow clients, as it will never ever use new-fangled things
    like non-blocking socket I/O, threads, epoll or kqueue.  unicorn
    must be used with a fully-buffering reverse proxy such as nginx
    for slow clients.
  * ISSUES: update with mailing list subscription
  * GIT-VERSION-GEN: start 5.0.0 development
  * http: remove xftrust options
  * FAQ: add entry for Rails autoflush_log
  * dev: remove isolate dependency
  * unicorn.gemspec: depend on test-unit 3.0
  * http_response: remove Status: header
  * remove RubyForge and Freecode references
  * remove mongrel.rubyforge.org references
  * http: remove the keepalive requests limit
  * http: reduce parser from 72 to 56 bytes on 64-bit
  * examples: add run_once to before_fork hook example
  * worker: remove old tmp accessor
  * http_server: save 450+ bytes of memory on x86-64
  * t/t0002-parser-error.sh: relax test for rack 1.6.0
  * remove SSL support
  * tmpio: drop the "size" method
  * switch docs + website to olddoc
  * README: clarify/reduce references to unicorn_rails
  * gemspec: fixup olddoc migration
  * use the monotonic clock under Ruby 2.1+
  * http: -Wshorten-64-to-32 warnings on clang
  * remove old inetd+git examples and exec_cgi
  * http: standalone require + reduction in binary size
  * GNUmakefile: fix clean gem build + reduce build cruft
  * socket_helper: reduce constant lookups and caching
  * remove 1.8, <= 1.9.1 fallback for missing IO#autoclose=
  * favor IO#close_on_exec= over fcntl in 1.9+
  * use require_relative to reduce syscalls at startup
  * doc: update support status for Ruby versions
  * fix uninstalled testing and reduce require paths
  * test_socket_helper: do not depend on SO_REUSEPORT
  * favor "a.b(&:c)" form over "a.b { |x| x.c }"
  * ISSUES: add section for bugs in other projects
  * http_server: favor ivars over constants
  * explain 11 byte magic number for self-pipe
  * const: drop constants used by Rainbows!
  * reduce and localize constant string use
  * Links: mark Rainbows! as historical, reference yahns
  * save about 200 bytes of memory on x86-64
  * http: remove deprecated reset method
  * http: remove experimental dechunk! method
  * socket_helper: update comments
  * doc: document UNICORN_FD in manpage
  * doc: document Etc.nprocessors for worker_processes
  * favor more string literals for cold call sites
  * tee_input: support for Rack::TempfileReaper middleware
  * support TempfileReaper in deployment and development envs
  * favor kgio_wait_readable for single FD over select
  * Merge tag 'v4.9.0'
  * http_request: support rack.hijack by default
  * avoid extra allocation for hijack proc creation
  * FAQ: add note about ECONNRESET errors from bodies
  * process SIGWINCH unless stdin is a TTY
  * ISSUES: discourage HTML mail strongly, welcome nyms
  * http: use rb_hash_clear in Ruby 2.0+
  * http_response: avoid special-casing for Rack < 1.5
  * www: install NEWS.atom.xml properly
  * http_server: remove a few more accessors and constants
  * http_response: simplify regular expression
  * move the socket into Rack env for hijacking
  * http: move response_start_sent into the C ext
  * FAQ: reorder bit on Rack 1.1.x and Rails 2.3.x
  * ensure body is closed during hijack
  === unicorn 4.9.0 - TempfileReaper support in Rack 1.6 / 2015-04-24 03:09 UTC
    This release supports the Rack::TempfileReaper middleware found
    in rack 1.6 for cleaning up disk space used by temporary files.
    We also use Rack::TempfileReaper for cleaning up large temporary
    files buffered with TeeInput.  Users on rack 1.5 and earlier
    will see no changes.
    There's also a bunch of documentation/build system improvements.
    This is likely to be the last Ruby 1.8-compatible release,
    unicorn 5.x will require 1.9.3 or later as well as dropping lots
    of cruft (the stupid "Status:" header in responses being the
    most notable).
    21 changes backported from master:
    ISSUES: update with mailing list subscription
    FAQ: add entry for Rails autoflush_log
    dev: remove isolate dependency
    unicorn.gemspec: depend on test-unit 3.0
    remove RubyForge and Freecode references
    remove mongrel.rubyforge.org references
    examples: add run_once to before_fork hook example
    t/t0002-parser-error.sh: relax test for rack 1.6.0
    switch docs + website to olddoc
    README: clarify/reduce references to unicorn_rails
    gemspec: fixup olddoc migration
    GNUmakefile: fix clean gem build + reduce build cruft
    doc: update support status for Ruby versions
    fix uninstalled testing and reduce require paths
    test_socket_helper: do not depend on SO_REUSEPORT
    ISSUES: add section for bugs in other projects
    explain 11 byte magic number for self-pipe
    Links: mark Rainbows! as historical, reference yahns
    doc: document UNICORN_FD in manpage
    tee_input: support for Rack::TempfileReaper middleware
    support TempfileReaper in deployment and development envs
* Sun Apr 26 2015 coolo@suse.com
- updated to version 4.9.0
  ChangeLog removed upstream
* Mon Sep 29 2014 mrueckert@suse.de
- update to new packaging scheme and add gem2rpm.yml
- added unicorn-4.6.3_fix_shebangline.patch + series file:
  Fixing some shebang lines
* Sun May 18 2014 coolo@suse.com
- updated to version 4.8.3
    This release updates documentation to reflect the migration of the
    mailing list to a new public-inbox[1] instance.  This is necessary
    due to the impending RubyForge shutdown on May 15, 2014.
    The public-inbox address is: unicorn-public@bogomips.org
    (no subscription required, plain text only)
    ssoma[2] git archives: git://bogomips.org/unicorn-public
    browser-friendly archives: http://bogomips.org/unicorn-public/
    Using, getting help for, and contributing to unicorn will never
    require any of the following:
    1) non-Free software (including SaaS)
    2) registration or sign-in of any kind
    3) a real identity (we accept mail from Mixmaster)
    4) a graphical user interface
    Nowadays, plain-text email is the only ubiquitous platform which
    meets all our requirements for communication.
    There is also one small bugfix to handle premature grandparent death
    upon initial startup.  Most users are unaffected.
    [1] policy: http://public-inbox.org/ - git://80x24.org/public-inbox
    an "archives first" approach to mailing lists
    [2] mechanism: http://ssoma.public-inbox.org/ - git://80x24.org/ssoma
    some sort of mail archiver (using git)
* Tue May  6 2014 adrian@suse.de
- fix license tag
* Sat Feb 22 2014 coolo@suse.com
- updated to version 4.8.2
    unicorn 4.8.2 - avoid race condition during worker startup
    fix races/error handling in worker SIGQUIT handler
* Mon Jan 20 2014 coolo@suse.com
- updated to version 4.8.0
  This release contains fairly major internal workings of master-to-worker
  notifications.  The master process no longer sends signals to workers
  for most tasks.  This works around some compatibility issues with some
  versions of the "pg" gem (and potentially any other code which may not
  handle EINTR properly).  One extra benefit is it also helps stray
  workers notice a rare, unexpected master death more easily.  Workers
  continue to (and will always) accept existing signals for compatibility
  with tools/scripts which may signal workers.
  PID file are always written early (even on upgrade) again to avoid
  breaking strange monitoring setups which use PID files.  Keep in mind we
  have always discouraged monitoring based on PID files as they are
  fragile.
  We now avoid bubbling IOError to the Rack app on premature client
  disconnects when streaming the input body.  This is usually not a
  problem with nginx, but may be on some LAN setups without nginx).
  Thanks to Sam Saffron, Jimmy Soho, Rodrigo Rosenfeld Rosas,
  Michael Fischer, and Andrew Hobson for their help with this release.
  Note: the unicorn mailing list will be moved/changed soon due to the
  RubyForge shutdown.  unicorn will always rely only on Free Software.
  There will never be any sign-up requirements nor terms-of-service to
  agree to when communicating with us.
* Fri Nov 22 2013 coolo@suse.com
- updated to version 4.7.0, see Changelog
  * unicorn is now GPLv2-or-later and Ruby 1.8-licensed
    (instead of GPLv2-only, GPLv3-only, and Ruby 1.8-licensed)
* Sun Jul 21 2013 coolo@suse.com
- updated to version 4.6.3
  - fix --no-default-middleware option
* Thu Mar 14 2013 mrueckert@suse.de
- update to version 4.6.2
  - This release fixes a bug in Unicorn::HttpParser#filter_body
    which affected some configurations of Rainbows!  There is
    also a minor size reduction in the DSO.
  - Unicorn::Const::UNICORN_VERSION is now auto-generated from
    GIT-VERSION-GEN and always correct.  Minor cleanups for
    hijacking.
* Sat Feb  9 2013 coolo@suse.com
- updated to version 4.6.0
  This pre-release adds hijacking support for Rack 1.5 users.
  See Rack documentation for more information about hijacking.
  There is also a new --no-default-middleware/-N option
  for the `unicorn' command to ignore RACK_ENV within unicorn
  thanks to Lin Jen-Shin.
  There are only documentation and test-portability updates
  since 4.6.0pre1, no code changes.
* Wed Dec 19 2012 mrueckert@suse.de
- update to version 4.5.0
  The new check_client_connection option allows unicorn to detect
  most disconnected local clients before potentially expensive
  application processing begins.
  This feature is useful for applications experiencing spikes of
  traffic leading to undesirable queue times, as clients will
  disconnect (and perhaps even retry, compounding the problem)
  before unicorn can even start processing the request.
  To enable this feature, add the following line to a unicorn
  config file:
    check_client_connection true
  This feature only works when nginx (or any other HTTP/1.0+
  client) is on the same machine as unicorn.
  A huge thanks to Tom Burns for implementing and testing this
  change in production with real traffic (including mitigating
  an unexpected DoS attack).
  ref: http://mid.gmane.org/CAK4qKG3rkfVYLyeqEqQyuNEh_nZ8yw0X_cwTxJfJ+TOU+y8F+w@mail.gmail.com
* Sun Oct 28 2012 coolo@suse.com
- updated to version 4.4.0
  Non-regular files are no longer reopened on SIGUSR1.  This
  allows users to specify FIFOs as log destinations.
  TCP_NOPUSH/TCP_CORK is no longer set/unset by default.  Use
  :tcp_nopush explicitly with the "listen" directive if you wish
  to enable TCP_NOPUSH/TCP_CORK.
  Listen sockets are now bound _after_ loading the application for
  preload_app(true) users.  This prevents load balancers from
  sending traffic to an application server while the application
  is still loading.
  There are also minor test suite cleanups.
* Wed Aug 24 2011 mrueckert@suse.de
- update to 4.1.0
  * Rack::Chunked and Rack::ContentLength middlewares are loaded
    by default for RACK_ENV=(development|deployment) users to match
    Rack::Server behavior.  As before, use RACK_ENV=none if you want
    fine-grained control of your middleware.  This should also
    help users of Rainbows! and Zbatery.
  * CTL characters are now rejected from HTTP header values
  * Exception messages are now filtered for [:cntrl:] characters
    since application/middleware authors may forget to do so
  * Workers will now terminate properly if a SIGQUIT/SIGTERM/SIGINT
    is received while during worker process initialization.
  * close-on-exec is explicitly disabled to future-proof against
    Ruby 2.0 changes [ruby-core:38140]
* Sat Jul  2 2011 ammler@openttdcoop.org
- major update to 4.0.1
  (too many changes to list here, please see
  /usr/lib*/ruby/gems/1.8/gems/unicorn-4.0.1/ChangeLog)
* Tue Jun 15 2010 mrueckert@suse.de
- initial package of version 0.991.0
